From af50cc5e3fe7eb3e75c349292f3ac3621e0b424f Mon Sep 17 00:00:00 2001
From: Chen Feiyue <69809761+chenfeiyue-cfy@users.noreply.github.com>
Date: Sat, 12 Aug 2023 10:04:16 +0800
Subject: [PATCH] Added general Float16 support (#631)

Added Float16 type definition from third-party
Refine float16 bias handlling in conv2d
Refine float16 case in conv2d
Caution: Headers of float16 only be included when build unit_test

Type: New Feature

Signed-off-by: Feiyue Chen <Feiyue.Chen@verisilicon.com>
---
 BUILD                                  |    2 +
 CMakeLists.txt                         |    2 +
 include/tim/vx/ops/conv2d.h            |    3 -
 src/tim/vx/ops/conv2d.cc               |   28 +-
 src/tim/vx/ops/conv2d_test.cc          |  354 +--
 third_party/half/ChangeLog.txt         |  184 ++
 third_party/half/ChangeLog.txt.license |    4 +
 third_party/half/LICENSE.spdx          |    7 +
 third_party/half/LICENSE.txt           |   21 +
 third_party/half/README.txt            |  288 +++
 third_party/half/README.txt.license    |    4 +
 third_party/half/half.hpp              | 3070 ++++++++++++++++++++++++
 12 files changed, 3771 insertions(+), 196 deletions(-)
 create mode 100644 third_party/half/ChangeLog.txt
 create mode 100644 third_party/half/ChangeLog.txt.license
 create mode 100644 third_party/half/LICENSE.spdx
 create mode 100644 third_party/half/LICENSE.txt
 create mode 100644 third_party/half/README.txt
 create mode 100644 third_party/half/README.txt.license
 create mode 100644 third_party/half/half.hpp

diff --git a/BUILD b/BUILD
index 0fcaf9f..368e645 100644
--- a/BUILD
+++ b/BUILD
@@ -134,8 +134,10 @@ cc_binary(
 cc_test (
     name = "unit_test",
     copts = ["-std=c++14", "-Werror"],
+    includes = ["third_party/half"],
     srcs = [
         "src/tim/vx/test_utils.h",
+        "third_party/half/half.hpp"
     ] + glob(["src/tim/**/*_test.cc"]),
     deps = [
         "@gtest//:gtest",
diff --git a/CMakeLists.txt b/CMakeLists.txt
index 72691e6..f77c8c4 100644
--- a/CMakeLists.txt
+++ b/CMakeLists.txt
@@ -98,6 +98,8 @@ if(TIM_VX_ENABLE_TEST)
         FetchContent_Populate(googletest)
         add_subdirectory(${googletest_SOURCE_DIR} ${googletest_BINARY_DIR})
     endif()
+
+    include_directories(third_party/half)
 endif()
 
 if(TIM_VX_ENABLE_GRPC)
diff --git a/include/tim/vx/ops/conv2d.h b/include/tim/vx/ops/conv2d.h
index f609960..72b2265 100644
--- a/include/tim/vx/ops/conv2d.h
+++ b/include/tim/vx/ops/conv2d.h
@@ -99,12 +99,9 @@ class Conv2d : public BuiltinOp {
   const int32_t multiplier_;
   const DataLayout kernel_layout_;
 
-#if defined(__clang__) && (__clang_major__ >= 15)
-#define TIM_VX_OPS_CONV2D_WITH_F16BIAS 1
  private:
   void OnBindInputPostProc(const std::shared_ptr<Tensor>& tensor,
                            int32_t input_idx) override;
-#endif
 };
 
 }  // namespace ops
diff --git a/src/tim/vx/ops/conv2d.cc b/src/tim/vx/ops/conv2d.cc
index 4f93b1c..d5130db 100644
--- a/src/tim/vx/ops/conv2d.cc
+++ b/src/tim/vx/ops/conv2d.cc
@@ -42,8 +42,8 @@ Conv2d::Conv2d(Graph* graph, const std::array<uint32_t, 4> pad,
                const std::array<uint32_t, 2>& stride,
                const std::array<uint32_t, 2>& dilation, int32_t multiplier,
                DataLayout input_layout, DataLayout kernel_layout)
-    : Conv2d(graph, 0, PadType::AUTO, {0, 0}, stride, dilation, pad,
-             multiplier, input_layout, kernel_layout) {}
+    : Conv2d(graph, 0, PadType::AUTO, {0, 0}, stride, dilation, pad, multiplier,
+             input_layout, kernel_layout) {}
 
 Conv2d::Conv2d(Graph* graph, int32_t weights, PadType padding,
                const std::array<uint32_t, 2>& ksize,
@@ -88,41 +88,33 @@ std::shared_ptr<Operation> Conv2d::Clone(std::shared_ptr<Graph>& graph) const {
       this->kernel_layout_);
 }
 
-const std::vector<std::shared_ptr<Tensor>> Conv2d::ConstantInputsTensor() const {
-   if (this->IsAllInputsConst()) {
+const std::vector<std::shared_ptr<Tensor>> Conv2d::ConstantInputsTensor()
+    const {
+  if (this->IsAllInputsConst()) {
     return {this->impl_->inputs_tensor_[0]};
   } else {
     return {};
   }
 }
 
-// Handle float16 bias if clang compiler is no less than 15.0.0 version
-#ifdef TIM_VX_OPS_CONV2D_WITH_F16BIAS
+// Handle float16 bias
 void Conv2d::OnBindInputPostProc(const std::shared_ptr<Tensor>& tensor,
                                  int32_t input_idx) {
   if (tensor->GetDataType() == vx::DataType::FLOAT16 &&
       tensor->IsConstTensor() && impl_->inputs_tensor_.size() == 3) {
-    uint32_t bias_size = 1;
-    for (auto i : tensor->GetShape()) {
-      bias_size *= i;
-    }
-    std::vector<_Float16> in(bias_size);
-    tensor->CopyDataFromTensor(in.data());
+    float* float32_bias = tensor->ConvertTensorToFloat32Data();
 
-    std::vector<float> out(bias_size);
-    for (uint i = 0; i < bias_size; i++) {
-      out[i] = static_cast<float>(in[i]);
-    }
     TensorSpec fp32bias_spec(tim::vx::DataType::FLOAT32, tensor->GetShape(),
                              tim::vx::TensorAttribute::CONSTANT);
-    auto out_tensor = impl_->graph_->CreateTensor(fp32bias_spec, out.data());
+
+    auto out_tensor = impl_->graph_->CreateTensor(fp32bias_spec, float32_bias);
+    vsi_nn_Free(float32_bias);
 
     impl_->inputs_tensor_[2] = out_tensor;
     impl_->node()->input.tensors[input_idx] = out_tensor->GetId();
     impl_->graph_->RenewTensorConsumersMap(tensor, out_tensor, this);
   }
 }
-#endif
 
 }  // namespace ops
 }  // namespace vx
